//It would be very hacky and difficult to make bricks able to be killed
//forever. I can give you the next best thing, 16 minutes and 39 seconds.
//Just set the Brick Respawn Time in the minigame menu to 999.
//Don't worry, bricks respawn on minigame reset.
//If you don't want them to respawn on minigame reset, event them like so:
//onResetRespawn, Self, fakeKillBrick [][][][999]
//If you find your bricks respawning and you really don't want them to
//try making your minigames not last as long.
$Game::MaxBrickRespawnTime = 999000;
registerOutputEvent(fxDTSBrick, fakeKillBrick, "vector\tint 0 999 5");
datablock particleData(respawnWandExplosionParticle)
{
	dragCoefficient = 2;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0.0;
	lifetimeMS = 200;
	lifetimeVarianceMS = 0;
	textureName = "base/data/particles/dot";
	spinSpeed = 10.0;
	spinRandomMin = 0.0;
	spinRandomMax = 0.0;
	colors[0] = "1 1 1 0.9";
	colors[1] = "1 1 0.5 1";
	colors[2] = "1 1 0 1";
	sizes[0] = 0.25;
	sizes[1] = 0.5;
	sizes[2] = 1;

	useInvAlpha = false;
};

datablock particleEmitterData(respawnWandExplosionEmitter)
{
	lifeTimeMS = 3000;
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 0.0;
	ejectionOffset	= 0.0;
	thetaMin = 80;
	thetaMax = 100;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = respawnWandExplosionParticle;
};

datablock explosionData(respawnWandExplosion)
{
	camShakeDuration = 0.5;
	camShakeFreq = "2 2 2";
	emitter[0] = "respawnWandExplosionEmitter";
	faceViewer = 1;
	lifetimeMS = 180;
	lightEndRadius = 0.5;
	lightStartColor = "0 0 0 0";
	lightStartRadius = 2.5;
	shakeCamera = 0;
	soundProfile = "wandHitSound";
};

datablock particleData(respawnWandParticleA)
{
	colors[0] = "1 1 0.5 0.9";
	colors[1] = "1 1 0.25 0.9";
	colors[2] = "1 1 0 0.9";
	colors[3] = "1 1 0 0.9";
	gravityCoefficient = 0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 0;
	sizes[0] = 0.05;
	sizes[1] = 0.1;
	sizes[2] = 0.15;
	spinRandomMax = 90;
	spinRandomMin = -90;
	textureName = "base/data/particles/nut";
	times[1] = 0.2;
	times[2] = 1;
};

datablock particleEmitterData(respawnWandEmitterA)
{
	ejectionOffset = 0.09;
	ejectionPeriodMS = 5;
	ejectionVelocity = 0.3;
	particles = "respawnWandParticleA";
	periodVarianceMS = 0;
	thetaMax = 180;
	velocityVariance = 0;
};

datablock particleData(respawnWandParticleB)
{
	colors[0] = "1 1 1 0.9";
	colors[1] = "1 1 1 0.9";
	colors[2] = "1 1 0.75 0.9";
	colors[3] = "1 1 0.5 0.9";
	gravityCoefficient = -0.2;
	inheritedVelFactor = 0.5;
	lifetimeMS = 200;
	lifetimeVarianceMS = 0;
	sizes[0] = 0.05;
	sizes[1] = 0.1;
	sizes[2] = 0.15;
	spinRandomMax = 90;
	spinRandomMin = -90;
	textureName = "base/data/particles/nut";
	times[1] = 0.8;
	times[2] = 1;
};

datablock particleEmitterData(respawnWandEmitterB)
{
	ejectionOffset	= 0.1;
	ejectionPeriodMS = 2;
	ejectionVelocity = 0.5;
	particles = "respawnWandParticleB";
	periodVarianceMS = 0;
	thetaMax = 180;
	velocityVariance = 0;
};

datablock projectileData(respawnWandProjectile)
{
	bounceElasticity = 0;
	bounceFriction	= 0;
	explodeOnDeath	= 1;
	explosion = "respawnWandExplosion";
	fadeDelay = 2;
	gravityMod = 0;
	lifetime = 0;
	mask = $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
	range = 25;
};

datablock itemData(respawnWandItem)
{
	cameraMaxDist	= 0.1;
	canDrop = 1;
	category = "Weapon";
	className = "Tool";
	colorShiftColor = "1 1 0 1";
	density	= 0.2;
	doColorShift = 1;
	elasticity = 0.2;
	emap = 1;
	friction = 0.6;
	iconName = "base/client/ui/itemIcons/wand";
	image = "respawnWandImage";
	shapeFile = "base/data/shapes/wand.dts";
	uiName = "Respawn Wand";
};

datablock shapeBaseImageData(respawnWandImage)
{
	ammo = " ";
	armReady = "1";
	className = "WeaponImage";
	colorShiftColor	= respawnWandItem.colorShiftColor;
	correctMuzzleVector = "0";
	doColorShift = "1";
	doRetraction = "0";
	eyeOffset = "0.7 1.2 -0.25";
	item = "respawnWandItem";
	melee = "1";
	projectile = "respawnWandProjectile";
	projectileType = "Projectile";
	shapeFile = "base/data/shapes/wand.dts";
	showBricks = "1";
	stateAllowImageChange[2]        = "0";
	stateEmitter[1]                 = "respawnWandEmitterA";
	stateEmitter[3]                 = "respawnWandEmitterB";
	stateEmitterNode[1]             = "muzzlePoint";
	stateEmitterNode[3]             = "blah";
	stateEmitterTime[1]             = "0.15";
	stateEmitterTime[3]             = "0.4";
	stateFire[3]                    = "1";
	stateName[0]                    = "Activate";
	stateName[1]                    = "Ready";
	stateName[2]                    = "PreFire";
	stateName[3]                    = "Fire";
	stateName[4]                    = "CheckFire";
	stateName[5]                    = "StopFire";
	stateScript[2]                  = "onPreFire";
	stateScript[3]                  = "onFire";
	stateScript[5]                  = "onStopFire";
	stateSequence[3]                = "fire";
	stateSequence[5]                = "StopFire";
	stateTimeoutValue[2]            = "0.1";
	stateTimeoutValue[3]            = "0.2";
	stateTimeoutValue[5]            = "0.2";
	stateTransitionOnTimeout[0]     = "ready";
	stateTransitionOnTimeout[1]     = "ready";
	stateTransitionOnTimeout[2]     = "fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTransitionOnTimeout[5]     = "ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateTransitionOnTriggerDown[4] = "fire";
	stateTransitionOnTriggerUp[4]   = "StopFire";
};

function respawnWandImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
	%obj.usedRWCommand = 0;
}

function serverCmdRespawnWand(%client)
{
	if(isObject(%player = %client.player) && (!isObject(%client.minigame) || %client.isSuperAdmin))
	{
		%player.updateArm("respawnWandImage");
		%player.mountImage("respawnWandImage", 0);
	}
}

function respawnWandImage::onFire(%this, %obj, %slot)
{
	if(!isObject(%obj.client))
		return;
	%start = %obj.getEyePoint();
	%end = vectorScale(%obj.getEyeVector(), %this.projectile.range);
	%rayCast = containerRayCast(%start, vectorAdd(%start, %end), %this.projectile.mask, %obj);
	%target = firstWord(%rayCast);
	if(!isObject(%target))
	{
		return;
	}
	%client = %obj.client;
	%pos = posFromRaycast(%raycast);
	%projectile = new projectile()
	{
		dataBlock = %this.projectile;
		initialVelocity = %obj.getEyeVector();
		initialPosition = %pos;
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %client;
	};
	missionCleanup.add(%projectile);
	%class = %target.getClassName();
	if(%class $= "Player" && %obj.client.isSuperAdmin && (!isObject(%client.minigame) || %target.client.minigame != %client.minigame || %obj.usedRWCommand))
		%target.client.spawnPlayer();
	else if((%class $= "AiPlayer" || %class $= "WheeledVehicle" || %class $= "FlyingVehicle") && (%client.isSuperAdmin || getTrustLevel(%obj,%target) >= 2))
	{
		if(getMiniGameFromObject(%target) == %client.minigame && isObject(%client.minigame))
			return;
		if(isObject(%target.spawnBrick))
			%target.spawnBrick.respawnVehicle();
		else
		{
			%tc = %target.getControllingClient();
			if(%tc > 0)
			{
				if(isObject(%tc.player))
					%tc.setControlObject(%tc.player);
				else
					%tc.setControlObject(%tc.camera);
			}
			%target.delete();
		}
	}
	else if((%class $= "AiPlayer" || %class $= "WheeledVehicle" || %class $= "FlyingVehicle") && !%obj.client.isSuperAdmin && getTrustLevel(%obj,%target) < 2 && isObject(%target.spawnBrick))
		commandToClient(%obj.client,'Centerprint',"<color:FF8888>" @ %target.spawnBrick.getGroup().name @ "<color:FF0000> does not trust you enough to do that.",2,2);
	else if(%class $= "fxDtsBrick")
	{
		%dist = vectorDist(%start,%pos);
		InitContainerRadiusSearch(%pos, 1.5, $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::FxBrickObjectType);
		while ((%targetObject = containerSearchNext()) != 0)
		{
			if (!miniGameCanDamage(%obj,%targetobject))
		  		continue;
			if(!isObject(%client.minigame))
			{
				if(!%targetObject.isFakeDead())
				{
					%targetObject.respawn();
					%targetObject.RWHighlight();
				}
				continue;
			}
			%volume = %targetObject.dataBlock.getVolume();
			%totalVolume+=%volume;
			if(!%targetObject.isFakeDead())
			{
				%recoveredVolume+=%volume;
				continue;
			}
			%targetObject.recovery+=(mPow(0.8,%dist)*3.75);
			if(%targetObject.recovery >= %volume)
			{
				%targetObject.recovery = 0;
				%targetObject.respawn();
				%targetObject.RWHighlight();
				%recoveredVolume+=%volume;
				continue;
			}
			%recoveredVolume+=%targetObject.recovery;
		}
		if(%totalVolume > 0 && isObject(%client.minigame))
			CenterPrint(%client,"<color:ffffff>Brick Recovery: <color:00ff00>" @ mFloor((%recoveredVolume/%totalVolume)*100) @ "<color:ffffff>%",3);
	}
}

function respawnWandImage::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armAttack");
}

function respawnWandImage::onStopFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}


//Difference between this highlight and duplicator's?
//This one prioritizes transparent bricks.
%target = "0.75 0.75 0.75 0.3";
for(%i = 0; %i < 64; %i++)
{
	%colori = getColorIdTable(%i);
	%dist = vectorDist(%colori, %target);
	//I know that this math below has nothing to do with caluating the
	//distance between 2 vectors, however, vectorDist only supports
	//3 numbers in a vector, and colors have 4 numbers.
	//I also want transparency to be high priority, not equal priority.
	if(getWord(%colori,3) > 0.3)
		%dist+=(getWord(%colori,3)-0.3);
	else
		%dist+=(0.3-getWord(%colori,3));
	if(%dist < %best || %best $= "")
	{
		%best = %dist;
		$RWHighlightColor = %i;
	}
}
function fxDtsBrick::RWHighlight(%this)
{
	if(%this.restoreSchedule $= "")
	{
		%this.oldColorId = %this.colorId;
		%this.oldColorFxId = %this.colorFxId;
		%this.setColor($RWHighlightColor);
		%this.setColorFx(3);
		%this.restoreSchedule = %this.schedule(2000, "RWRestore");
	}
	else
	{
		cancel(%this.restoreSchedule);
		%this.restoreSchedule = %this.schedule(2000, "RWRestore");
	}
}

function fxDtsBrick::RWRestore(%this)
{
	%this.restoreSchedule = "";
	%this.setColor(%this.oldColorId);
	%this.setColorFx(%this.oldColorFxId);
	%this.oldColorId = "";
	%this.oldColorFxId = "";
}		

package RWMinigame
{
	function MinigameSO::reset(%mini,%client)
	{
		Parent::reset(%mini,%client);
		if(%mini.useAllPlayersBricks)
			for(%x=0;%x<%mini.numMembers;%x++)
				respawnPartGroup(%mini.member[%x].brickGroup);
		else
			respawnPartGroup(%client.brickGroup);
	}
	function serverCmdEndMinigame(%client)
	{
		%mini = %client.minigame;
		if(isObject(%mini) && %mini.owner == %client)
			for(%x=0;%x<%mini.numMembers;%x++)
				respawnPartGroup(%mini.member[%x].brickGroup);
		Parent::serverCmdEndMinigame(%client);
	}
	function serverCmdLeaveMinigame(%client)
	{
		if(!isObject(%client.minigame))
			return;
		Parent::serverCmdLeaveMinigame(%client);
		respawnPartGroup(%client.brickGroup);
	}
	function fxDTSBrick::onRespawn(%this,%a1,%a2)
	{
		%this.recovery = 0;
		return Parent::onRespawn(%this,%a1,%a2);
	}
	function serverCmdRTB_setServerPrefs(%client,%prefs,%var0,%var1,%var2,%var3,%var4,%var5,%var6,%var7,%var8,%var9,%var10,%var11,%var12,%var13,%var14,%var,%var15)
	{
		//In the past, I've made an add-on that changes
		//the max brickrespawntime.
		//However, it does not allow for 999 seconds.
		//This bypasses that.
		%ret = Parent::serverCmdRTB_setServerPrefs(%client,%prefs,%var0,%var1,%var2,%var3,%var4,%var5,%var6,%var7,%var8,%var9,%var10,%var11,%var12,%var13,%var14,%var,%var15);
		$Game::MaxBrickRespawnTime = 999000;
	}
			
};
activatePackage(RWMinigame);

function respawnPartGroup(%group)
{
	//Some people may set brick respawn times really high
	//to make use of the Respawn Wand, however
	//bricks do not respawn until their time is up no matter
	//what. To keep people from waiting for 999 seconds for bricks
	//(such as their important base defenses!) to respawn, they'll
	//all instantly respawn when the minigame is reset.
	//
	//This is tested on a below-average system, and this
	//function produced minimal lag.
	cancel(%group.respawnPart);
	if(%group.x $= "")
		%group.x = 0;
	for(%x=%group.x;%x<%group.x+200 && %x<%group.getCount();%x++)
		if(%group.getObject(%x).isFakeDead())
		{
			%group.getObject(%x).respawn();
			%group.getObject(%x).onResetRespawn(%group.client);
		}
	if(%x==%group.x+200)
	{
		%group.x+=200;
		%group.respawnPart = schedule(1,0,respawnPartGroup,%group);
	}
	else
		%group.x=0;
}

//So you can fakeKillBricks when the minigame resets without having them
//instantly die when you respawn wand it.
registerInputEvent("fxDTSBrick", "onResetRespawn", "Self fxDTSBrick");

function fxDTSBrick::onResetRespawn(%obj,%client)
{
	$InputTarget_["Self"] = %obj;
	%obj.processInputEvent("OnResetRespawn",%client);
}